/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
	"time"
)


// CVEIDApiService CVEIDApi service
type CVEIDApiService service

type ApiCveIdGetFilteredRequest struct {
	ctx context.Context
	ApiService *CVEIDApiService
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	state *string
	cveIdYear *string
	timeReservedLt *time.Time
	timeReservedGt *time.Time
	timeModifiedLt *time.Time
	timeModifiedGt *time.Time
	page *int32
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveIdGetFilteredRequest) CVEAPIORG(cVEAPIORG string) ApiCveIdGetFilteredRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveIdGetFilteredRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveIdGetFilteredRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveIdGetFilteredRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveIdGetFilteredRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// Filter by state 
func (r ApiCveIdGetFilteredRequest) State(state string) ApiCveIdGetFilteredRequest {
	r.state = &state
	return r
}

// Filter by the year of the CVE IDs
func (r ApiCveIdGetFilteredRequest) CveIdYear(cveIdYear string) ApiCveIdGetFilteredRequest {
	r.cveIdYear = &cveIdYear
	return r
}

// Most recent reserved timestamp to retrieve. Include with all requests potentially returning multiple pages of CVE IDs to avoid issues if new IDs are reserved during use. &lt;br&gt;&lt;br&gt; &lt;i&gt;Timestamp format&lt;/i&gt; : yyyy-MM-ddTHH:mm:ssZZZZ
func (r ApiCveIdGetFilteredRequest) TimeReservedLt(timeReservedLt time.Time) ApiCveIdGetFilteredRequest {
	r.timeReservedLt = &timeReservedLt
	return r
}

// Earliest CVE ID reserved timestamp to retrieve &lt;br&gt;&lt;br&gt; &lt;i&gt;Timestamp format&lt;/i&gt; : yyyy-MM-ddTHH:mm:ssZZZZ
func (r ApiCveIdGetFilteredRequest) TimeReservedGt(timeReservedGt time.Time) ApiCveIdGetFilteredRequest {
	r.timeReservedGt = &timeReservedGt
	return r
}

// Most recent modified timestamp to retrieve. Include with all requests using a time_modified.gt filter potentially returning multiple pages of CVE IDs. This will avoid issues if IDs are reserved or modified during use.&lt;br&gt;&lt;br&gt; &lt;i&gt;Timestamp format&lt;/i&gt; : yyyy-MM-ddTHH:mm:ssZZZZ
func (r ApiCveIdGetFilteredRequest) TimeModifiedLt(timeModifiedLt time.Time) ApiCveIdGetFilteredRequest {
	r.timeModifiedLt = &timeModifiedLt
	return r
}

// Earliest CVE ID modified timestamp to retrieve &lt;br&gt;&lt;br&gt; &lt;i&gt;Timestamp format&lt;/i&gt; : yyyy-MM-ddTHH:mm:ssZZZZ
func (r ApiCveIdGetFilteredRequest) TimeModifiedGt(timeModifiedGt time.Time) ApiCveIdGetFilteredRequest {
	r.timeModifiedGt = &timeModifiedGt
	return r
}

// The current page in the paginator
func (r ApiCveIdGetFilteredRequest) Page(page int32) ApiCveIdGetFilteredRequest {
	r.page = &page
	return r
}

func (r ApiCveIdGetFilteredRequest) Execute() (*ListCveIdsResponse, *http.Response, error) {
	return r.ApiService.CveIdGetFilteredExecute(r)
}

/*
CveIdGetFiltered Retrieves information about CVE IDs after applying the query parameters as filters (accessible to all registered users)

  <h2>Access Control</h2>  <p>All registered users can access this endpoint</p>  <h2>Expected Behavior</h2>  <p><b>Regular, CNA & Admin Users:</b> Retrieves filtered CVE IDs owned by the user's organization</p>  <p><b>Secretariat:</b> Retrieves filtered CVE IDs owned by any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiCveIdGetFilteredRequest
*/
func (a *CVEIDApiService) CveIdGetFiltered(ctx context.Context) ApiCveIdGetFilteredRequest {
	return ApiCveIdGetFilteredRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return ListCveIdsResponse
func (a *CVEIDApiService) CveIdGetFilteredExecute(r ApiCveIdGetFilteredRequest) (*ListCveIdsResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ListCveIdsResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVEIDApiService.CveIdGetFiltered")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve-id"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	if r.state != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "state", r.state, "")
	}
	if r.cveIdYear != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "cve_id_year", r.cveIdYear, "")
	}
	if r.timeReservedLt != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "time_reserved.lt", r.timeReservedLt, "")
	}
	if r.timeReservedGt != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "time_reserved.gt", r.timeReservedGt, "")
	}
	if r.timeModifiedLt != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "time_modified.lt", r.timeModifiedLt, "")
	}
	if r.timeModifiedGt != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "time_modified.gt", r.timeModifiedGt, "")
	}
	if r.page != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "page", r.page, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveIdGetSingleRequest struct {
	ctx context.Context
	ApiService *CVEIDApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveIdGetSingleRequest) CVEAPIORG(cVEAPIORG string) ApiCveIdGetSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveIdGetSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveIdGetSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveIdGetSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveIdGetSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiCveIdGetSingleRequest) Execute() (*GetCveIdResponse, *http.Response, error) {
	return r.ApiService.CveIdGetSingleExecute(r)
}

/*
CveIdGetSingle Retrieves information about the specified CVE ID (accessible to all users)

  <h2>Access Control</h2>  <p>Endpoint is accessible to all</p>  <h2>Expected Behavior</h2>  <p><b>Regular, CNA & Admin Users: </b>Retrieves full information about a CVE ID owned by their organization; partial information about a CVE ID owned by other organizations</p>  <p><b>Unauthenticated Users: </b>Retrieves partial information about a CVE ID  <p><b>Secretariat: </b>Retrieves full information about a CVE ID owned by any organization</p>  <p><i><b>Note - </b>The owning organization of RESERVED CVE IDs is redacted for all users other than those in the owning organization or Secretariat</i></p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The id of the CVE ID information to retrieve
 @return ApiCveIdGetSingleRequest
*/
func (a *CVEIDApiService) CveIdGetSingle(ctx context.Context, id string) ApiCveIdGetSingleRequest {
	return ApiCveIdGetSingleRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return GetCveIdResponse
func (a *CVEIDApiService) CveIdGetSingleExecute(r ApiCveIdGetSingleRequest) (*GetCveIdResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetCveIdResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVEIDApiService.CveIdGetSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve-id/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 429 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveIdRangeCreateRequest struct {
	ctx context.Context
	ApiService *CVEIDApiService
	year int32
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveIdRangeCreateRequest) CVEAPIORG(cVEAPIORG string) ApiCveIdRangeCreateRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveIdRangeCreateRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveIdRangeCreateRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveIdRangeCreateRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveIdRangeCreateRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiCveIdRangeCreateRequest) Execute() (*http.Response, error) {
	return r.ApiService.CveIdRangeCreateExecute(r)
}

/*
CveIdRangeCreate Creates a CVE-ID-Range for the specified year (accessible to Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Creates a CVE-ID-Range for the specified year</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param year The year of the CVE-ID-Range
 @return ApiCveIdRangeCreateRequest
*/
func (a *CVEIDApiService) CveIdRangeCreate(ctx context.Context, year int32) ApiCveIdRangeCreateRequest {
	return ApiCveIdRangeCreateRequest{
		ApiService: a,
		ctx: ctx,
		year: year,
	}
}

// Execute executes the request
func (a *CVEIDApiService) CveIdRangeCreateExecute(r ApiCveIdRangeCreateRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVEIDApiService.CveIdRangeCreate")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve-id-range/{year}"
	localVarPath = strings.Replace(localVarPath, "{"+"year"+"}", url.PathEscape(parameterValueToString(r.year, "year")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return nil, reportError("cVEAPIKEY is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiCveIdReserveRequest struct {
	ctx context.Context
	ApiService *CVEIDApiService
	amount *int32
	cveYear *int32
	shortName *string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	batchType *string
}

// Quantity of CVE IDs to reserve
func (r ApiCveIdReserveRequest) Amount(amount int32) ApiCveIdReserveRequest {
	r.amount = &amount
	return r
}

// The year the CVE IDs will be reserved for (i.e., 1999, ..., currentYear + 1)
func (r ApiCveIdReserveRequest) CveYear(cveYear int32) ApiCveIdReserveRequest {
	r.cveYear = &cveYear
	return r
}

// The CNA that will own the reserved CVE IDs
func (r ApiCveIdReserveRequest) ShortName(shortName string) ApiCveIdReserveRequest {
	r.shortName = &shortName
	return r
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveIdReserveRequest) CVEAPIORG(cVEAPIORG string) ApiCveIdReserveRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveIdReserveRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveIdReserveRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveIdReserveRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveIdReserveRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// Required when amount is greater than one, determines whether the reserved CVE IDs should be sequential or non-sequential
func (r ApiCveIdReserveRequest) BatchType(batchType string) ApiCveIdReserveRequest {
	r.batchType = &batchType
	return r
}

func (r ApiCveIdReserveRequest) Execute() (*CreateCveIdsResponse, *http.Response, error) {
	return r.ApiService.CveIdReserveExecute(r)
}

/*
CveIdReserve Reserves CVE IDs for the organization provided in the short_name query parameter (accessible to CNAs and Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>CNA</b> or <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>CNA:</b> Reserves CVE IDs for the CNA</p>  <p><b>Secretariat:</b> Reserves CVE IDs for any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiCveIdReserveRequest
*/
func (a *CVEIDApiService) CveIdReserve(ctx context.Context) ApiCveIdReserveRequest {
	return ApiCveIdReserveRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return CreateCveIdsResponse
func (a *CVEIDApiService) CveIdReserveExecute(r ApiCveIdReserveRequest) (*CreateCveIdsResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CreateCveIdsResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVEIDApiService.CveIdReserve")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve-id"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.amount == nil {
		return localVarReturnValue, nil, reportError("amount is required and must be specified")
	}
	if r.cveYear == nil {
		return localVarReturnValue, nil, reportError("cveYear is required and must be specified")
	}
	if r.shortName == nil {
		return localVarReturnValue, nil, reportError("shortName is required and must be specified")
	}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	parameterAddToHeaderOrQuery(localVarQueryParams, "amount", r.amount, "")
	if r.batchType != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "batch_type", r.batchType, "")
	}
	parameterAddToHeaderOrQuery(localVarQueryParams, "cve_year", r.cveYear, "")
	parameterAddToHeaderOrQuery(localVarQueryParams, "short_name", r.shortName, "")
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveIdUpdateSingleRequest struct {
	ctx context.Context
	ApiService *CVEIDApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	org *string
	state *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveIdUpdateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiCveIdUpdateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveIdUpdateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveIdUpdateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveIdUpdateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveIdUpdateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// The shortname of the new owning_cna for the CVE ID
func (r ApiCveIdUpdateSingleRequest) Org(org string) ApiCveIdUpdateSingleRequest {
	r.org = &org
	return r
}

// The new state for the CVE ID
func (r ApiCveIdUpdateSingleRequest) State(state string) ApiCveIdUpdateSingleRequest {
	r.state = &state
	return r
}

func (r ApiCveIdUpdateSingleRequest) Execute() (*UpdateCveIdResponse, *http.Response, error) {
	return r.ApiService.CveIdUpdateSingleExecute(r)
}

/*
CveIdUpdateSingle Updates information related to the specified CVE ID (accessible to CNAs and Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>CNA</b> or <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>CNA:</b> Updates information related to a CVE ID owned by the CNA</p>  <p><b>Secretariat:</b> Updates a CVE ID owned by any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The id of the CVE ID to update
 @return ApiCveIdUpdateSingleRequest
*/
func (a *CVEIDApiService) CveIdUpdateSingle(ctx context.Context, id string) ApiCveIdUpdateSingleRequest {
	return ApiCveIdUpdateSingleRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return UpdateCveIdResponse
func (a *CVEIDApiService) CveIdUpdateSingleExecute(r ApiCveIdUpdateSingleRequest) (*UpdateCveIdResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UpdateCveIdResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVEIDApiService.CveIdUpdateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve-id/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	if r.org != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "org", r.org, "")
	}
	if r.state != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "state", r.state, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
